//-----------------------------------------------------
// Aȉ~ϕ̊mFvO
// fϊłK̒l 1>K>0 ͈̔͂ƂȂ܂̂
// K = 1 Ɓ@K =0 ̏ꍇɂĕʓrǉĂ܂B
// {ZMPArithgpĂ܂B
// uses  mp_types, mp_real@̒ǉKvłB
// MPArith ɂĂ͉LQƂĂB
// "http://www.wolfgang-ehrhardt.de/mp_intro.html"
//-----------------------------------------------------
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, mp_types, mp_real;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Edit7: TEdit;
    Label7: TLabel;
    Edit8: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Edit9: TEdit;
    LabeledEdit3: TLabeledEdit;
    Button2: TButton;
    Label10: TLabel;
    Edit10: TEdit;
    Label11: TLabel;
    Edit11: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    function second_imperfect_elliptic_integral(Q, K: Extended; var EBnKnAns, FBnKnAns: Extended): boolean;
    function second_imperfect_elliptic_integral_bignum_arithmetic(strk, strQ: string; var EBnKnAns, FBnKnAns: mp_float): boolean;
    procedure bignum_arithmetic;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Math;

//-------------------------------
// PQȉ~ϕ
// FBnKn[0] Pȉ~ϕ
// EBnKn[0] Qȉ~ϕ
// fϊ
// Q px deg
// K S
// {Z MPArith@gp
//-------------------------------
function TForm1.second_imperfect_elliptic_integral_bignum_arithmetic(strk, strQ: string; var EBnKnAns, FBnKnAns: mp_float): boolean;
label
  OUTEX, OUTTR;
const
  K180 = 180;
  K90  =  90;
  K2   =   2;
  K1   =   1;
var
  I, MI   : integer;
  Kn      : array of mp_float;         // Kn
  knd     : array of mp_float;         // k'n
  N2SKn   : array of mp_float;         // 2/(1+Kn)
  T2SKnd  : array of mp_float;         // P2/(1+Kn')
  BRad    : array of mp_float;         // (rad)
  SinBn   : array of mp_float;         // sinn
  FBnKn   : array of mp_float;         // F(n,kn)
  EBnKn   : array of mp_float;         // E(n,kn)
  LnD     : mp_float;
  mp_pi   : mp_float;
  tmp     : mp_float;
  tmp0    : mp_float;
  mp_180  : mp_float;
  mp_90   : mp_float;
  mp_i    : mp_float;
  Emp     : mp_float;
  Qmp, Kmp    : mp_float;
  tmp1,tmp2   : mp_float;
  mp_1, mp_2  : mp_float;
//  str     : mp_string;
  astrK   : ansistring;
  astrQ   : ansistring;
  mperrF  : boolean;
  K       : extended;
begin
  result := false;
  mperrF := false;
  mpf_init(LnD);
  mpf_init(mp_pi);
  mpf_init(tmp);
  mpf_init(tmp0);
  mpf_init(mp_180);
  mpf_init(mp_90);
  mpf_init(mp_i);
  mpf_init(Emp);
  mpf_init2(Qmp, Kmp);
  mpf_init2(tmp1,tmp2);
  mpf_init2(mp_1, mp_2);

// K̃Zbg
// K Uextendedɕϊ
  K := strtofloat(strk);
// l@1E-4951@Ō[ɂȂ܂  double ̏ꍇ1E-309
  if K = 0 then strk := '0';
  astrK := ansistring(strk);
  // K ̒lɃ[ɋ߂ꍇG[ɂȂ̂ňꉞmF
  // K < 1E-10000-----
  try
    mp_real.mpf_read_decimal(Kmp, PAnsiChar(astrK));
  except
  // on MPXBAdarg do ShowMessage('MpfError Raised');
    on MPXBAdarg do mperrF := true;
  end;
  if mperrF then begin
    ShowMessage('Mpf Error Raised');
    goto OUTTR;
  end;

// K̒lz̑傫Ă܂
  mp_real.mpf_read_decimal(tmp, PAnsiChar(astrK));
  MI := 0;
  // emptmpœlo܂ŌJԂ܂
  repeat
    inc(MI);
    mpf_add_int(tmp, 0, Emp);     // Emp  = tmp
    mpf_sqrt(tmp, tmp1);          // tmp1 = sqrt(tmp)
    mpf_Mul_int(tmp1, 2, tmp2);   // tmp2 = 2 * sqrt(tmp)
    mpf_add_int(tmp, 1, tmp0);    // tmp0 = 1 + tmp
    mpf_div(tmp2, tmp0, tmp);     // tmp  = (2 * sqrt(tmp)) / (1 + tmp)
  until mpf_is_eq(Emp, tmp);      // Emp  tmp I@

  setlength(Kn,     MI);         // Kn
  setlength(knd,    MI);         // k'n
  setlength(N2SKn,  MI);         // 2/(1+Kn)
  setlength(T2SKnd, MI);         // P2/(1+Kn')
  setlength(BRad,   MI);         // (rad)
  setlength(SinBn,  MI);         // sinn
  setlength(FBnKn,  MI);         // F(n,kn)
  setlength(EBnKn,  MI);         // E(n,kn)

  dec(MI);

  for I := 0 to MI do begin
    mpf_init(kn[I]);
    mpf_init(knd[I]);
    mpf_init(N2SKn[I]);
    mpf_init(T2SKnd[I]);
    mpf_init(BRad[I]);
    mpf_init(SinBn[I]);
    mpf_init(FBnKn[I]);
    mpf_init(EBnKn[I]);
  end;

// Q̃Zbg
  astrQ := ansistring(strq);
  mp_real.mpf_read_decimal(Qmp, PAnsiChar(astrQ));

// 萔̃Zbg
  mpf_set_int(mp_90,  K90);
  mpf_set_int(mp_180, K180);
  mpf_set_int(mp_1, K1);
  mpf_set_int(mp_2, K2);
  mpf_set_pi(mp_pi);

// K = 0 ͉̎~Ȃ̂pi̊pxlradB
  if mpf_is0(Kmp) then begin
    mpf_mul(mp_pi, Qmp, tmp);
    mpf_div(tmp, mp_180, EBnKnAns);
    mpf_div(tmp, mp_180, FBnKnAns);
    result := true;
    goto OUTEX;
  end;
// K = 1  Q=90 ̎
// vZł͓ôŃG[
// ȂȂlɂ܂B
  mpf_abs(Qmp, tmp);
  if mpf_is1(Kmp) then begin
    if mpf_is_eq(tmp, mp_90) then begin
      mpf_set1(EBnKnAns);
      if s_mpf_is_neg(Qmp) then s_mpf_chs(EBnKnAns);
      result := true;
      goto OUTEX;
    end;
    if mpf_is_gt(tmp, mp_90) then begin
      goto OUTEX;
    end;
  end;
// kn[0] := k;
  mp_real.mpf_read_decimal(KN[0], PAnsiChar(astrK));
  for I := 1 to MI do begin
//    kn[I] := 2 * sqrt(Kn[I - 1])/(1 + Kn[I - 1]);
    mpf_add(kn[I - 1], mp_1, tmp);
    mpf_sqrt(Kn[I - 1], tmp0);
    mpf_div(tmp0, tmp, tmp1);
    mpf_mul(tmp1, mp_2, kn[I]);
  end;
  mpf_set1(knd[0]);
  for I := 1 to MI do begin
//    knd[I] := (1 - kn[I - 1]) / (1 + Kn[I - 1]);
    mpf_sub(mp_1, kn[I - 1], tmp);
    mpf_add(mp_1, kn[I - 1], tmp0);
    mpf_div(tmp, tmp0, knd[I]);
  end;
  for I := 0 to MI do begin
//    N2SKn[I] := 2 / (1 + kn[I]);
    mpf_add(mp_1, kn[I], tmp0);
    mpf_div(mp_2, tmp0, N2SKn[I]);
  end;
//  T2SKnd[MI] := N2SKn[MI];
  mpf_div(mp_2, tmp0, T2SKnd[MI]);
//  str := mpf_decimal(T2SKnd[MI], 50);

  for I := MI - 1 downto 0 do
//    T2SKnd[I] := T2SKnd[I + 1] * N2SKn[I];
    mpf_mul(T2SKnd[I + 1], N2SKn[I], T2SKnd[I]);
//  BRad[0] := Q / 180 * pi;
  mpf_div(Qmp, mp_180, tmp);
  mpf_mul(tmp, mp_pi, BRad[0]);
  for I := 1 to MI do begin
//    BRad[I] := (arcsin(kn[I - 1] * sin(Brad[I - 1])) + Brad[I - 1]) / 2;
    mpf_sin(Brad[I - 1], tmp);
    mpf_mul(kn[I - 1], tmp, tmp0);
    mpf_arcsin(tmp0, tmp);
    mpf_add(tmp, Brad[I - 1], tmp1);
    mpf_div(tmp1, mp_2, BRad[I]);
  end;
  for I := 0 to MI do
//    SinBn[I] := sin(Brad[I]);
    mpf_sin(Brad[I], SinBn[I]);

//  LnD := LN((1 + sin(Brad[MI])) / cos(Brad[MI]));
  // tmp = sin(Brad[MI]
  mpf_sin(Brad[MI], tmp);
  // tmp0 := 1 + sin(Brad[MI])
  mpf_add(tmp, mp_1, tmp0);
  // tmp  := cos(Brad[MI)
  mpf_cos(Brad[MI], tmp);
  // tmp0 := (1 + sin(Brad[MI])) / cos(Brad[MI]);
  mpf_div(tmp0, tmp, tmp0);
// tmp0 <= 0 ̏ꍇRΐϊłȂ̂ŌvZł؂
  if s_mpf_is_le0(tmp0) then goto OUTEX;
  // LnD := Ln(tmp0);
  mpf_Ln(tmp0, LnD);

  for I := 0 to MI do begin
//    FBnKn[I] := T2SKnd[I] * LnD;
    mpf_mul(T2SKnd[I], LnD, FBnKn[I]);
    if I = 0 then mpf_mul(T2SKnd[I], LnD, FBnKnans);
  end;
//  EBnKn[MI] := sin(Brad[MI]);
  mpf_sin(Brad[MI], EBnKn[MI]);
  for I := MI - 1 downto 0 do begin
//    EBnKn[I] :=  (2 * EBnKn[I + 1] + 2 * knd[I + 1] * FBnKn[I + 1]) / (1 + knd[I + 1]) - kn[I] * SinBn[I];
    mpf_mul(EBnKn[I + 1], mp_2, tmp);
    mpf_mul(knd[I + 1], mp_2, tmp0);
    mpf_mul(tmp0, FBnKn[I + 1], tmp1);
    mpf_add(tmp, tmp1, tmp2);
    mpf_add(knd[I + 1], mp_1, tmp);
    mpf_div(tmp2, tmp, tmp0);
    mpf_mul(kn[I], SinBn[I], tmp);
    mpf_sub(tmp0, tmp, EBnKn[I]);
  end;
//  EBnKnans := EBnKn[0];
  mpf_copy(EBnKn[0], EBnKnans);
//  str := mpf_decimal(EBnKn[0], 50);
//  str := mpf_decimal(kn[MI], 50);
//  Edit4.Text := string(str);
  result := true;

OUTEX:
  for I := 0 to MI do begin
    mpf_clear(kn[I]);
    mpf_clear(knd[I]);
    mpf_clear(N2SKn[I]);
    mpf_clear(T2SKnd[I]);
    mpf_clear(BRad[I]);
    mpf_clear(SinBn[I]);
    mpf_clear(FBnKn[I]);
    mpf_clear(EBnKn[I]);
  end;
OUTTR:
  mpf_clear(LnD);
  mpf_clear(mp_pi);
  mpf_clear(tmp);
  mpf_clear(tmp0);
  mpf_clear(mp_180);
  mpf_clear(mp_90);
  mpf_clear(mp_i);
  mpf_clear(Emp);
  mpf_clear2(Qmp, Kmp);
  mpf_clear2(tmp1,tmp2);
  mpf_clear2(mp_1, mp_2);
end;

//-------------------------------------------------------------------
// {fϊ
// ͌̈׈xpx͒lstringextended̕_ɕϊ
// XextendedstringɕϊĂ܂B
//-------------------------------------------------------------------
procedure TForm1.bignum_arithmetic;
label
  ERREXIT;
var
  EBnKnans, EBnKn90     : mp_float;
  tmp, EBnKnAll         : mp_float;
  FBnKnAll              : mp_float;
  FBnKnans, FBnKn90     : mp_float;
  Q, AQ                 : Extended;
  strK, strQ            : string;
  str                   : ansistring;
  I, J                  : integer;
  KnAllF                : boolean;
begin
  mpf_init2(EBnKnans, EBnKn90);
  mpf_init2(tmp, EBnKnALL);
  mpf_init3(FBnKnans, FBnKn90, FBnKnAll);

  strK := LabeledEdit1.Text;
  strQ := LabeledEdit2.Text;
// Uextendedɕϊ
  Q := strtofloat(strQ);
// Ql@1E-4951@Ō[ɐݒ double 1E-309
  if Q = 0 then strQ := '0'
           else strQ := floatTostr(Q);
// ꊇvZvZ---------------------------------------------------------------------------
  KnAllF := second_imperfect_elliptic_integral_bignum_arithmetic(strk, strQ, EBnKnAll, FBnknAll);
  // vZʂ̕\
  if KnAllF then begin
    str := mpf_decimal(EBnKnAll, 50);
    Edit4.Text := string(str);
    str := mpf_decimal(FBnKnAll, 50);
    Edit9.Text := string(str);
  end
  else begin
    Edit4.Text := 'vZo܂"px""K"ĉB';
    Edit9.Text := 'vZo܂"px""K"ĉB';
//    goto ERREXIT;
  end;
// 90vZ --------------------------------------------------------------------------
  strQ := '90';
// vZppx
  AQ := ABS(Q);
// 90̔{vZ
  I  := trunc(AQ / 90);
// 90vZ
  mpf_set0(EBnKn90);
  mpf_set0(FBnKn90);
  if I > 0 then second_imperfect_elliptic_integral_bignum_arithmetic(strk, strQ, EBnKn90, FBnKn90);
// 90̔{pɑ΂]pxvZ یɂČvZ@ύX
  if I mod 2 = 0 then
    strQ := floatTostr(AQ - 90 * I)
  else
    strQ := floatTostr(90 * (I + 1)  - AQ);
// ݒ肳ꂽ]p̌vZ
  second_imperfect_elliptic_integral_bignum_arithmetic(strk, strQ, EBnKnans, FBnKnans);
// 90{pƗ]p̉Z  یɂČvZ@ύX
  if I mod 2 = 0 then begin
    J := I;
    mpf_mul_int(EBnKn90, J, tmp);
    mpf_add(tmp, EBnKnans, EBnKnans);
    mpf_mul_int(FBnKn90, J, tmp);
    mpf_add(tmp, FBnKnans, FBnKnans);
  end
  else begin
    J := I + 1;
    mpf_mul_int(EBnKn90, J, tmp);
    mpf_sub(tmp, EBnKnans, EBnKnans);
    mpf_mul_int(FBnKn90, J, tmp);
    mpf_sub(tmp, FBnKnans, FBnKnans);
  end;
// px̕Ɍʂ킹܂B
  if Q < 0 then begin
    s_mpf_chs(EBnKnans);
    s_mpf_chs(FBnKnans);
  end;
// vZʂ̕\
  str := mpf_decimal(EBnKnans, 50);
  Edit5.Text := string(str);
  // K = 1 ł 90ȏ̑ϕ͕sŁɂȂ܂B
  if (strTofloat(strK) >= 1) and (AQ >= 90) then begin
    str := '';
    Edit9.Text := string(str);
  end
  else str := mpf_decimal(FBnKnans, 50);
  Edit8.Text := string(str);
// ̕\
  if KnAllF then begin
    mpf_sub(EBnKnAll, EBnKnans, tmp);
    str := mpf_decimal(tmp, 50);
    Edit6.Text := string(str);
  end
  else
    Edit6.Text :='';
ERREXIT:
  mpf_clear3(FBnKnans, FBnKn90, FBnKnAll);
  mpf_clear2(EBnKnans, EBnKn90);
  mpf_clear2(tmp, EBnKnAll);
end;

//-------------------------------
// PQȉ~ϕ
// FBnKn[0] Pȉ~ϕ
// EBnKn[0] Qȉ~ϕ
// fϊ
// Q px deg
// K S
//-------------------------------
function TForm1.second_imperfect_elliptic_integral(Q, K: Extended; var EBnKnAns, FBnKnAns: Extended): boolean;
var
  I, MI   : integer;
  Kn      : array of Extended;         // Kn
  knd     : array of Extended;         // k'n
  N2SKn   : array of Extended;         // 2/(1+Kn)
  T2SKnd  : array of Extended;         // P2/(1+Kn')
  BRad    : array of Extended;         // (rad)
  SinBn   : array of Extended;         // sinn
  FBnKn   : array of Extended;         // F(n,kn)
  EBnKn   : array of Extended;         // E(n,kn)
  LnD, nD : Extended;
begin
  result := true;
  // z̐ݒ
  // l"1"o܂ł肩܂B
  // LND = 1 ł͎̔gpł܂
  // fobO̕\"1" łŏIrbgt߂Ɍ덷܂
  MI  := 0;
  LnD := K;
  repeat
    inc(MI);
    nD := LnD;
    LnD := 2 * sqrt(nD) / (1 + nD);
  until LND = nD;

  setlength(Kn,      MI);         // Kn
  setlength(knd,     MI);         // k'n
  setlength(N2SKn,   MI);         // 2/(1+Kn)
  setlength(T2SKnd,  MI);         // P2/(1+Kn')
  setlength(BRad,    MI);         // (rad)
  setlength(SinBn,   MI);         // sinn
  setlength(FBnKn,   MI);         // F(n,kn)
  setlength(EBnKn,   MI);         // E(n,kn)

  dec(MI);

  // K = 0 ͉̎~Ȃ̂pi̊pxlradB
  if K = 0 then begin
    EBnKnAns := pi * Q / 180;
    FBnKnAns := EBnKnAns;
    exit;
  end;
  // K = 1  Q=90 ̎
  // vZł͓ôŃG[
  // ȂȂlɂ܂B
  if K = 1 then begin
    if abs(Q) = 90 then begin
      if Q > 0 then EBnKnAns :=  1
               else EBnKnAns := -1;
      FBnKnAns := 0;                    // ۂ́
//      FBnKnAns := MAXExtended;
      exit;
    end;
    if abs(Q) > 90 then begin
      result := False;        // ZG[ݒ
      exit;
    end;
  end;
  // 1 > K > 0 ̎
  kn[0] := K;
  for I := 1 to MI do kn[I] := 2 * sqrt(Kn[I - 1])/(1 + Kn[I - 1]);
  knd[0] := 1;
  for I := 1 to MI do knd[I] := (1 - kn[I - 1]) / (1 + Kn[I - 1]);
  for I := 0 to MI do N2SKn[I] := 2 / (1 + kn[I]);
  T2SKnd[MI] := N2SKn[MI];
  for I := MI - 1 downto 0 do T2SKnd[I] := T2SKnd[I + 1] * N2SKn[I];
  BRad[0] := Q / 180 * pi;
  for I := 1 to MI do BRad[I] := (arcsin(kn[I - 1] * sin(Brad[I - 1])) + Brad[I - 1]) / 2;
  for I := 0 to MI do SinBn[I] := sin(Brad[I]);
  nD := (1 + sin(Brad[MI])) / cos(Brad[MI]);
  // nd  O傫ȂƎRΐɕϊł܂B
  if nD <= 0 then begin
    result := False;
    exit;
  end;
  LnD := LN(nD);
  for I := 0 to MI do  FBnKn[I] := T2SKnd[I] * LnD;
  EBnKn[MI] := sin(Brad[MI]);
  for I := MI - 1 downto 0 do
    EBnKn[I] :=  (2 * EBnKn[I + 1] + 2 * knd[I + 1] * FBnKn[I + 1]) / (1 + knd[I + 1]) - kn[I] * SinBn[I];
  EBnKnAns := EBnKn[0];
  FBnKnAns := FBnKn[0];
end;

//---------------------------------------------------------
// pxpvZƃfϊɂvZ
// SK̒l0.9𒴂ƁAϕłpx܂B
// K = 1 ̏ꍇ ϕł̂90łB
// pxpɂvŹAK=1 łȂvZł܂B
//---------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
var
  I, N            : integer;
  K, Q, dq, Wq    : Extended;
  x1, y1, x2, y2  : Extended;
  S, ds, b        : Extended;
  dx, dy          : Extended;
  rnd, Frnd       : Extended;
  RAN90, Qd       : Extended;
  RANQd, RANQ     : Extended;
  D90, SDQ, AQ    : Extended;
  FAN90, FANQ     : Extended;
  FANQd           : Extended;
  rndF            : boolean;
  // pϕ
  procedure elliptic_integera(Q : Extended);
  var
    I : integer;
  begin
    N := round(Q * 10000);                    // ݒ
    N := abs(N);
    if N = 0 then N := 1;                     // ł̏Zh~
    Q := Q / 180 * pi;                        // pxradɕϊ
    dq := Q / N;                              // vZ
    S := 0;                                   // ϕlNA
    x1 := cos(0) * b;                         // x1=cos()*b͒Z x1=cos()
    y1 := sin(0);                             // y1=sin()  ͒Z y1=sin()*b
    for I := 1 to N do begin                  // wpϕvZ
      wq := I * dq;
      x2 := cos(wq) * b;                      // x2=cos()*b͒Z x2=cos()
      y2 := sin(wq);                          // y2=sin()  ͒Z y2=sin()*b
      dx := x2 - x1;
      dy := y2 - y1;
      ds := sqrt(dx * dx + dy * dy);          // p̋
      S := S + ds;                            // a 
      x1 := x2;
      y1 := y2;
    end;
  end;

begin
  val(LabeledEdit1.Text, K, I);
  if I <> 0 then begin
    application.MessageBox('K̒lɊԈႢ܂B','SK',0);
    exit;
  end;
  if K > 1 then begin
    application.MessageBox('K̒l͂PłB','SK',0);
    exit;
  end;
  if K < 0 then begin
    application.MessageBox('K̒l[ȉłB','SK',0);
    exit;
  end;
  val(LabeledEdit2.Text, Q, I);
  if I <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','ϕp',0);
    exit;
  end;

// ϕ͈Xɕϊ
  D90 := int(Q / 90);                     // 90̐{
  SDQ := Q - D90 * 90;                    // c̊px
  SDQ := SDQ / 180 * pi;                  // radɕϊ
  AQ := sin(SDQ) + D90;                   // sinϊ
  Labelededit3.Text := floatTostr(AQ);    // ϕ͈XZbg


// {ɂ郉fϊvZ-------------------------------------------
  bignum_arithmetic;

// fϊɂvZ-------------------------------------------------
  // vZppx𕄍Ȃ
  AQ := abs(Q);
  rndF := second_imperfect_elliptic_integral(Q, K, rnd, Frnd);
  if rndF then begin
    Edit2.Text := floatTostr(rnd);
    // K = 1 ł 90ȏ̑ϕ͕sŁɂȂ܂B
    if (K = 1) and (AQ >= 90) then
      Edit10.Text := ''
    else
      Edit10.Text := floatTostr(Frnd);
  end
  else begin
    Edit2.Text  := 'vZo܂"px""K"ĉB';
    Edit10.Text := 'vZo܂"px""K"ĉB';
  end;
// 90fϊ---------------------------------------------------
  // 90̔{vZ
  I := Trunc(AQ / 90);
  // 90̌vZ
  RAN90 := 0;
  FAN90 := 0;
  if I > 0 then second_imperfect_elliptic_integral(90, K, RAN90, FAN90);
  // vZ͈͂̐ݒ یɂĎc蕔̐ݒ
  if I mod 2 = 0 then Qd := AQ - I * 90
                 else Qd := (I + 1) * 90 - AQ;
  // ݒ肳ꂽc͈͂̌vZ
  second_imperfect_elliptic_integral(Qd, K, RANQd, FANQd);
  // ͊px̐ϕlvZ یɂČvZύX
  if I mod 2 = 0 then begin
    RANQ :=  I      * RAN90 + RANQd;
    FANQ :=  I      * FAN90 + FANQd;
  end
  else begin
    RANQ := (I + 1) * RAN90 - RANQd;
    FANQ := (I + 1) * FAN90 - FANQd;
  end;
  // pxɂĕݒ
  if Q < 0 then begin
    RANQ := -RANQ;
    FANQ := -FANQ;
  end;
  Edit7.Text := floatTostr(RANQ);
  // K = 1 ł 90ȏ̑ϕ͕sŁɂȂ܂B
  if (K = 1) and (AQ >= 90) then begin
    Edit10.Text := '';
    Edit11.Text := '';
  end
  else
    Edit11.Text := floatTostr(FANQ);

// pxpɂϕvZ-------------------------------------------
// 90 ȂĂpϕȂ̂ŏo܂vZxグ邽
// 90Pʂŋ؂ČvZ܂B
// 傫ȊpxłAő180̌vZōς݂܂B
  // abvZ aa͂Pŏȗ
  b := sqrt(1 - K * K);
  // 90̔{vZ
  I := Trunc(AQ / 90);
  // 90̐ϕlvZ
  S := 0;
  if I > 0 then elliptic_integera(90);
  D90 := S;                                 // 90x̐ϕl
  // vZ͈͂̐ݒ یɂĎc蕔̐ݒ
  if I mod 2 = 0 then Qd :=  AQ - I * 90
                 else Qd := (I + 1) * 90 - AQ;
  // ݒ肳ꂽc͈͂̌vZ
  elliptic_integera(Qd);
  // ͊px̐ϕlvZ یɂČvZύX
  if I mod 2 = 0 then SDQ :=  I      * D90 + S
                 else SDQ := (I + 1) * D90 - S;
  // ̌vZȂ̂ŕȂApxɍ킹ĕݒ肵܂B
  if Q < 0 then SDQ := -SDQ;
  Edit1.Text := floattostr(SDQ);

// vZ\-----------------------------------------------------------
  if rndF then          // rnd = false ZG[
    Edit3.Text := floattostr(rnd - SDQ)
  else
    Edit3.Text := '';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Q, X  : double;
  XS, J : double;
  Qs    : double;
  ch    : integer;
begin
  val(Labelededit3.Text, X, Ch);
  if ch <> 0 then begin
    application.MessageBox('X̒lɊԈႢ܂B','ϕ͈X',0);
    exit;
  end;
  J := int(X);                          // 
  Xs := X - J;                          // o
  Qs := arcsin(Xs) / pi * 180;          // pxdegɕϊ
  Q := J * 90 + Qs;                     // pxƏpxZ
  Labelededit2.Text := floatTostr(Q);   // ϕpxɃZbg
  Button1Click(nil);                    // ϕs
end;

end.
